#include <strings.h>
#include <math.h>
#include "my_gfx.h"

/* Zmienne globalne */
extern DWORD *tunnel_table1;
extern DWORD *tunnel_table2;
extern DWORD *tunnel_table;

#define PERSPVAL 3500           // Promien tunelu
void Create_tunnel_table(BYTE persp, DWORD *tun_tabl)
{
   int    x, y;
   double dst;
   int    tx, ty;
   DWORD  *temp;

  temp = tun_tabl;
  for(y = 0; y < 200; y++)
    for(x = 0; x < 320; x++, temp++) {
      /* Znalezienie odleglosci punktu od srodka ekranu */
      dst = sqrt( (x - 160) * (x - 160) + (y - 100) * (y - 100) );

      /* Obliczenie wspolrzednej x */
      if( ( y == 100) && ( x == 160 ) )
        tx = 128;
      else tx = (int) ( 128 * atan2( (double)(y-100), (double)(x-160) ) / PI + 0.5);

      /* Obliczenie wspolrzednej y */
     if( persp ) {
       if ( (int) dst ) {
         ty =  PERSPVAL / (int) (dst + 0.5);
       }
       else {
         /* Srodek ekranu - dst=0 wiec nie dzielimy */
         ty = 128;
       }
     }
     else {
       if ( (int) dst ) {
         ty =  (int) (dst + 0.5);
       }
       else {
         /* Srodek ekranu - dst=0 wiec nie dzielimy */
         ty = 128;
       }
     }

     /* Zapis punktu do tablicy */
     *temp = (tx << 8) + ty;
    }
}

void Do_tunnel(bitmap *b, BYTE *dst, WORD increment)
{
  int   offs;
  BYTE  *temp;
  DWORD *temp2;
  WORD  temp3;

  temp  = dst;
  temp2 = tunnel_table;
  for(offs = 0; offs < 64000; offs++, temp++, temp2++) {
    temp3 = *temp2 + increment;
    *temp = *(b->data + temp3);
  }
}
